@echo off

:: ---------------------------------------------------------------------------
:: Settings

set KeyboardLayoutFileName=KBDFA.DLL

:: ---------------------------------------------------------------------------
:: Displaying installer information

echo Ŀ
echo  Chortkeh Keyboard Layout Installer                                         
echo  Revision 3                                                                 
echo  November 4, 2008                                                           
echo  Copyright (c) 1999-2008 Chortkeh Technologies, LLC. All rights reserved.   
echo  Command-line scripting by Komeil Bahmanpour.                               
echo 
echo.

:: ---------------------------------------------------------------------------
:: Windows version detection

echo Setup is detecting Windows version...
ver | find "Version 6." > nul
if %errorlevel% equ 0 (
  echo Microsoft Windows Vista/Server 2008 [Version 6] detected.
  set WindowsVersion=6
  goto :BypassVersionError
)
ver | find "Version 5." > nul
if %errorlevel% equ 0 (
  echo Microsoft Windows XP/Server 2003 [Version 5] detected.
  set WindowsVersion=5
  goto :BypassVersionError
)
echo Inappropriate Windows version. Setup must be run under one of the following
echo operating systems:
echo.
echo * Microsoft Windows Vista
echo * Microsoft Windows Server 2008
echo * Microsoft Windows XP
echo * Microsoft Windows Server 2003
echo 
pause
goto :eof
:: Mandatory for older Windows versions incapable of understanding EOF,
:: eventhough they don't take CMD files as BAT.
exit

:: ---------------------------------------------------------------------------
:: Initialization

:BypassVersionError
:: Preserve current directory for further referrings.
set InitialDirectory=%cd%
:: Change drive and path to where the batch file was started from. This is
:: required when your batch file is run-as-administrator, because it sets
:: System32 the working (current) directory.
cd /d "%0\.."
echo.
echo.
echo *** WARNING! ***
echo.
if %WindowsVersion%==5 (
  echo Please REMOVE Windows installation CD from the drive.
  echo.
)
echo Once finished, Setup will RESTART the system without any notification.
echo Therefore, save any unsaved work and close any opened applications before
echo proceeding with the installation.
echo.
echo [C] to continue with the installation.
echo [Q] to quit.
:: Get user's input.
:ChoiceLoop
echo.
set Choice=
set /p Choice=Select an option and press [Enter] to proceed.
if not "%Choice%"=="" set Choice=%Choice:~0,1%
if /i "%Choice%" equ "q" goto :eof
if /i "%Choice%" equ "c" goto :BypassChoiceLoop
echo Unacceptable choice.
goto :ChoiceLoop
:BypassChoiceLoop
cls
if %WindowsVersion%==5 goto :InstallForXp
if %WindowsVersion%==6 goto :InstallForVista

:: ---------------------------------------------------------------------------
:: XP installation
 
:InstallForXp
echo Copying %KeyboardLayoutFileName% to system's DLL cache...
xcopy /r /y /h /q %KeyboardLayoutFileName% "%SystemRoot%\system32\dllcache"
echo.
echo Copying %KeyboardLayoutFileName% to system...
xcopy /r /y /h /q %KeyboardLayoutFileName% "%SystemRoot%\system32"
echo.
if errorlevel 1 goto :Error
echo.
echo *** WARNING! ***
echo.
echo Do NOT answer the Windows File Protection dialog.
echo.
goto :SystemRestart

:: ---------------------------------------------------------------------------
:: Vista installation
 
:InstallForVista
echo Taking the ownership of system's existing %KeyboardLayoutFileName%...
takeown /f "%SystemRoot%\system32\%KeyboardLayoutFileName%"
echo.
echo Granting %username% full-access permission to system's existing %KeyboardLayoutFileName%...
icacls "%SystemRoot%\system32\%KeyboardLayoutFileName%" /grant "%UserName%":F
echo.
echo Copying %KeyboardLayoutFileName% to system...
xcopy /r /y /h /q %KeyboardLayoutFileName% "%SystemRoot%\system32"
echo.
if errorlevel 1 goto :Error
goto :SystemRestart

:: ---------------------------------------------------------------------------
:: Restarting the system immediately

:SystemRestart
echo System will now restart...
shutdown /r /t 0 /d p:4:1
pause > nul
goto :eof

:: ---------------------------------------------------------------------------
:: Error management

:Error
echo Error installing %KeyboardLayoutFileName%
echo.
echo Setup will now exit.
echo 
pause
goto :eof

:: ---------------------------------------------------------------------------
:: Remarks

:: In Vista, there's another copy in here:
:: C:\Windows\winsxs\x86_microsoft-windows-i..l-keyboard-00000429_31bf3856ad364e35_6.0.6001.18000_none_eace302b61f01104\KBDFA.DLL
:: Some say it's good to delete it, but I don't think so.

:: In XP, an immidiate restart is necessary to prevent Windows File Protection from restoring the original file.
